Last Comment Bug 456169 - Add "Tag" button to new interface for message headers (missing widget in header pane toolbar customization palette)
: Add "Tag" button to new interface for message headers (missing widget in head...
Status: VERIFIED FIXED
:
Product: Thunderbird
Classification: Client Software
Component: Message Reader UI (show other bugs)
: Trunk
: All All
: -- enhancement with 3 votes (vote)
: Thunderbird 14.0
Assigned To: Magnus Melin
:
:
Mentors:
Depends on:
Blocks: tb-tagsmeta msgreadertracker 725507 519956 tb-tabsontop
  Show dependency treegraph
 
Reported: 2008-09-20 00:29 PDT by Mitra Ardron
Modified: 2013-02-23 16:00 PST (History)
13 users (show)
mkmelin+mozilla: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
proposed fix (5.30 KB, patch)
2012-03-31 05:03 PDT, Magnus Melin
mconley: review-
Details | Diff | Splinter Review
proposed fix v2 (6.13 KB, patch)
2012-04-11 12:53 PDT, Magnus Melin
mconley: review+
Details | Diff | Splinter Review
followup fix, v1 (1.54 KB, patch)
2012-04-23 12:28 PDT, Magnus Melin
bwinton: review+
bwinton: ui‑review+
Details | Diff | Splinter Review

Description Mitra Ardron 2008-09-20 00:29:39 PDT
User-Agent:       Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; en-GB; rv:1.9.0.2) Gecko/2008090512 Firefox/3.0.2
Build Identifier: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; en-US; rv:1.9.1b1pre) Gecko/20080917025353 Shredder/3.0b1pre

In the new headers layout - there are two buttons / functions that would be good to add to the grey-blue bar.  These were previously available in a plugin that doesn't look like its been updated to current versions. 

a) Transfer to a folder - drop down, but defaulting to last folder transfered to
b) Add Tag - a drop down, but defaulting to last tag added. 

The reason is to do with how I see people work (especially me :-) I'm flicking through a lot of messages, and filing away ones that are done, and tagging ones that aren't. With the old plug in this used to work great, (kbd shortcuts etc) with the new interface its labor-intensve as each has to be dragged individually. 

Reproducible: Always

Steps to Reproduce:
1.
2.
3.
Comment 1 Wayne Mery (:wsmwk, NI for questions) 2009-01-18 09:57:36 PST
Mitra, iirc your "transfer" idea exist as one or more "archive" bugs (and if not please file one), so I'm morphing this to just tagging

Is there a significant use case that makes this much better than using keyboard shortcuts 1, 2, 3, ...?
Comment 2 Mitra Ardron 2009-01-18 13:17:32 PST
This is really one pair of problems that are closely related, i.e. how do you file messages efficiently.

For Tags: Keyboard shortcuts are only useful if you only have less than 9 Tags, I consistently run with about 30 or 40 - for example one group of tags relate to the people I have passed a task onto. 

The plugin I mentioned (Nostalgy) now works on Shredder, so maybe the need is met that way. 

In Nostalgy you hit "S" to Save something, then key in the name of the folder - with autocomplete.  Shift-S saves to the same location as the last one, and S:foo would tag something as foo. 

Its a nice design and makes this process much more efficient. 

- Mitra
Comment 3 Thomas D. (currently busy elsewhere; needinfo?me) 2009-11-07 00:33:41 PST
We definitely need optional tag button in header bar customization palette. It's a strongly message-related command and as such should be available from header.
I think there's a bug for this, but can't find right now, so marking this new.
Comment 4 Joachim Herb 2009-11-07 04:47:07 PST
The CompactHeader add-on (https://addons.mozilla.org/de/thunderbird/addon/13564) gives you the ability to customize the buttons in the header pane. It also adds the "save" and "tag" buttons as possible choices. You have to right click on the header pane to get to the customization menu/dialog.

Unfortunately these buttons have no default behavior as described in comment #0. You always have to choose which folder the message to move or which tag to add. The add-on just clones the buttons from the main mail toolbar. So it would probably best to change the behavior of the buttons there, i.e. change type of buttons from "menu" to "menu-button".

In the context menu of the message list there is already an item to move the message to the folder which was used as target for the last move. So this functionality would be there and could be reused for the save button. I am not sure if the last tag used is somewhere saved.
Comment 5 Ludovic Hirlimann [:Usul] 2009-11-09 02:46:02 PST
Thomas, don't dupme if you searched already and pass the bug to new ....
Comment 6 Jim Porter (:squib) 2010-06-26 11:42:38 PDT
Note: just adding a "tag" button to the message header toolbar won't be enough, since it should also be present in the multi-message summary (which really should be made into a proper toolbar too).
Comment 7 Thomas D. (currently busy elsewhere; needinfo?me) 2010-06-27 01:26:10 PDT
(In reply to comment #6)
> Note: just adding a "tag" button to the message header toolbar won't be enough,
> since it should also be present in the multi-message summary (which really
> should be made into a proper toolbar too).

Absolutely. However, this bug just wants to complete the single-msg header bar, which unfortunately is the only customizable header toolbar so far.
There's a separate bug for the multiple-messages header:

Bug 523544  - With multiple messages selected, many command buttons are missing on header bar and contextual menu (junk, reply[-all], forward, tag, etc.)

It's sad users have to fight for the customizability of each button and each bar individually (and even for all buttons to have icons...). For some obscure reason, TB devs seem to have a tendency of resisting full customizability, especially if it involves toolbars (well perhaps it's more work initially, but cleaner design, less bugs and less usability complaints ever after!). QuickFilter Bar is another example where they've done it again... zero customizability. Instead, there should be a design policy that anything bar-like must be technically designed as a full-fledged toolbar. *sigh*
Comment 8 Magnus Melin 2012-03-29 12:27:16 PDT
I'll take a look at this.
Comment 9 Magnus Melin 2012-03-31 05:03:06 PDT
Created attachment 611152 [details] [diff] [review]
proposed fix

Add the tag button.
Comment 10 Mike Conley (:mconley) - (needinfo me!) 2012-04-05 13:42:04 PDT
Comment on attachment 611152 [details] [diff] [review]
proposed fix

Stealing this review request.
Comment 11 Mike Conley (:mconley) - (needinfo me!) 2012-04-05 14:00:07 PDT
Comment on attachment 611152 [details] [diff] [review]
proposed fix

Review of attachment 611152 [details] [diff] [review]:
-----------------------------------------------------------------

Hey Magnus,

I think you're missing a change to messageHeader-aero.css.  Could you update that one too please?

This looks pretty good though.  Just one other nit that I found below.

r-'ing for those things for now.  When you get a new patch up, I'll also take the opportunity to try it across qute/pinstripe/gnomestripe.

Thanks,

-Mike

::: mail/base/content/msgHdrViewOverlay.xul
@@ +308,5 @@
> +                             class="toolbarbutton-1 msgHeaderView-button hdrTagButton"
> +                             label="&tagButton.label;"
> +                             tooltiptext="&tagButton.tooltip;"
> +                             command="cmd_tag">
> +                <menupopup id="hdrTagDropDown" onpopupshowing="InitMessageTags(this)">

Personally, I think these elements should have id's with "Popup" as opposed to "Dropdown" in it, since technically, these are popups....but I won't ask you to change the world here.

Instead, for consistencies sake, please change the ID from "hdrTagDropDown" to "hdrTagDropdown" to match the other elements in this file.
Comment 12 Magnus Melin 2012-04-11 12:53:43 PDT
Created attachment 614129 [details] [diff] [review]
proposed fix v2

With aero.
Comment 13 Mike Conley (:mconley) - (needinfo me!) 2012-04-16 13:18:12 PDT
Comment on attachment 614129 [details] [diff] [review]
proposed fix v2

Review of attachment 614129 [details] [diff] [review]:
-----------------------------------------------------------------

Looks good and works as advertised.

Thanks Magnus.
Comment 14 Magnus Melin 2012-04-19 10:53:30 PDT
http://hg.mozilla.org/comm-central/rev/96209faea907 -> FIXED
Comment 15 Jim Porter (:squib) 2012-04-19 21:25:28 PDT
We'll need some icon work on this: Linux needs an SVG icon, Mac could use the tag icon added to message-header-toolbar.png, XP could probably use large and small versions of the CSS (or just remove the large versions, since I don't think they're used), and Aero probably needs #hdrTagButton added here: http://mxr.mozilla.org/comm-central/source/mail/themes/qute/mail/primaryToolbar-aero.css#265
Comment 16 Magnus Melin 2012-04-23 12:28:19 PDT
Created attachment 617598 [details] [diff] [review]
followup fix, v1

Fix the aero issue. Lets leave the rest for another bug...
Comment 17 Magnus Melin 2012-04-23 12:31:25 PDT
Yup, the large versions didn't seem used, thats why i didn't add one.

Re the rest of the issues: it may be cleaner code wise, any other reason for those?
Comment 18 Blake Winton (:bwinton) (:☕️) 2012-05-01 10:30:12 PDT
Comment on attachment 617598 [details] [diff] [review]
followup fix, v1

The code seems good, so r=me, and the change makes it look better, I think, so ui-r=me, too, while I'm here.  :)

Thanks,
Blake.
Comment 19 Magnus Melin 2012-05-09 11:26:49 PDT
Comment on attachment 617598 [details] [diff] [review]
followup fix, v1

So, this didn't get to land. (That code went away with http://hg.mozilla.org/comm-central/rev/01e0db038845)
Comment 20 Magnus Melin 2012-05-09 12:27:11 PDT
Bug 753478 filed for comment 15
Comment 21 Thomas D. (currently busy elsewhere; needinfo?me) 2013-02-22 07:51:21 PST
*** Bug 546978 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.